#include "mbed.h"

class Watchdog {
public:
// Load timeout value in watchdog timer and enable
    void set(float s) {
        LPC_WDT->WDCLKSEL = 0x1;                // Set CLK src to PCLK
        uint32_t clk = SystemCoreClock>>4;      // WD has a fixed /4 prescaler, PCLK default is /4
        LPC_WDT->WDTC = s * (float)clk;
        LPC_WDT->WDMOD = 0x3;                   // Enabled and Reset
        renew();
    }
// "kick" or "feed" the dog - reset the watchdog timer
// by writing this required bit pattern
    void renew() {
        LPC_WDT->WDFEED = 0xAA;
        LPC_WDT->WDFEED = 0x55;
    }
};
